unit Unit1;

interface

uses
  Windows, Messages, SysUtils,Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls,U8085, Buttons, ComCtrls, Grids, Menus,
  AppEvnts, ToolWin, ActnList,Mask,UEdit, ULCD;

type
 TInsInfo=record
  name:string;
  pos:integer;
  size:integer;
 end;

 TMsgInfo=record
  msgid:integer;
  name:string;
  color:TColor;
  continue:boolean;
 end;

 TBPSpace=array[0..2047] of longword;
 PBPSpace=^TBPSpace;
type
  TCPU = class(TForm)
    MemSource: TMemo;
    FValSign:  TLabel;
    FValZero:  TLabel;
    FValParity:TLabel;
    FValAux:   TLabel;
    FValCarry: TLabel;
    CapFlagS: TLabel;
    CapFlagZ: TLabel;
    CapFlagAC:TLabel;
    CapFlagP: TLabel;
    CapFlagC: TLabel;
    CapRegA:  TLabel;
    CapRegB:  TLabel;
    CapRegD:  TLabel;
    CapRegC:  TLabel;
    CapRegL:  TLabel;
    CapRegH:  TLabel;
    CabRegM:  TLabel;
    CapRegE:  TLabel;
    CapRegPC: TLabel;
    CapRegSP: TLabel;
    CapRegPSW:TLabel;
    RegValA:  TLabel;
    RegValB:  TLabel;
    RegValC:  TLabel;
    RegValD:  TLabel;
    RegValE:  TLabel;
    RegValH:  TLabel;
    RegValL:  TLabel;
    RegValM:  TLabel;
    RegvalPSW:TLabel;
    RegValSP: TLabel;
    RegValPC: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    Bevel8: TBevel;
    Bevel9: TBevel;
    Bevel10: TBevel;
    Bevel11: TBevel;
    Bevel12: TBevel;
    Bevel13: TBevel;
    Bevel14: TBevel;
    Bevel15: TBevel;
    Bevel16: TBevel;
    Bevel17: TBevel;
    Bevel18: TBevel;
    Bevel19: TBevel;
    Bevel20: TBevel;
    Bevel21: TBevel;
    Bevel22: TBevel;
    Bevel23: TBevel;
    Bevel24: TBevel;
    Bevel25: TBevel;
    Bevel26: TBevel;
    Bevel27: TBevel;
    Bevel28: TBevel;
    Bevel29: TBevel;
    Bevel31: TBevel;
    LabCharno: TLabel;
    LabStatus: TLabel;
    LabLno: TLabel;
    Label6: TLabel;
    Label10: TLabel;
    Label11: TLabel;

    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    ActionList1 :TActionList;
    ActCompile  :TAction;
    ActExecute  :TAction;
    ActStep     :TAction;
    ActSaveAs: TAction;
    ActOpen     :TAction;
    ActReset    :TAction;
    ActTerminate:TAction;
    PopupMenu1: TPopupMenu;
    MenGoto: TMenuItem;
    MenCValue: TMenuItem;
    MenCins: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    CodeGrid:TDrawGrid;
    MemGrid: TDrawGrid;
    CodeBar: TScrollBar;
    MemBar : TScrollBar;
    Timer1: TTimer;
    Bevel30: TBevel;
    Bevel32: TBevel;
    SpeedButton8: TSpeedButton;
    ActExit: TAction;
    ClearAllBreakpoints1: TMenuItem;
    SpeedButton9: TSpeedButton;
    ActSave: TAction;
    SpeedButton10: TSpeedButton;
    ActClose: TAction;
    MasterSave: TAction;
    LCD1: TLCD;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    ActTrace: TAction;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure CodeGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure CodeGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CodeBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure CodeBarChange(Sender: TObject);
    procedure MemGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure MemBarChange(Sender: TObject);
    procedure MemGridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure MemGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure MemGridKeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure MemSourceClick(Sender: TObject);
    procedure MemSourceKeyPress(Sender: TObject; var Key: Char);
    procedure MemSourceKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ActCompileHint(var HintStr: String; var CanShow: Boolean);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure ActTerminateHint(var HintStr: String; var CanShow: Boolean);
    procedure ActStepHint(var HintStr: String; var CanShow: Boolean);
    procedure ActExecuteHint(var HintStr: String; var CanShow: Boolean);
    procedure MenGotoClick(Sender: TObject);
    procedure MemGridContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure RegValAContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure MenCValueClick(Sender: TObject);
    procedure MemGridGetEditMask(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure ActSaveAsHint(var HintStr: String; var CanShow: Boolean);
    procedure SpeedButton6Click(Sender: TObject);
    procedure ActOpenHint(var HintStr: String; var CanShow: Boolean);
    procedure SpeedButton7Click(Sender: TObject);
    procedure ActResetHint(var HintStr: String; var CanShow: Boolean);
    procedure CodeGridContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure MenCinsClick(Sender: TObject);
    procedure SourceBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure SpeedButton8Click(Sender: TObject);
    procedure ActExitHint(var HintStr: String; var CanShow: Boolean);
    procedure ClearAllBreakpoints1Click(Sender: TObject);
    procedure ActSaveHint(var HintStr: String; var CanShow: Boolean);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure MemSourceChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MasterSaveExecute(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure CodeGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure ActTraceHint(var HintStr: String; var CanShow: Boolean);
  private
   fopenfile:string;
   fbplist:PBpspace;
   fProcessor:T8085;
   fstep,fmodify:boolean;
   forigin,ftmpval:integer;
   fcurline,fmsgfront,fmsgrear:integer;
   finsinfo:array[0..10] of TinsInfo;
   ftmpvals:array[0..15] of integer;
   fmsgqueue:array[0..9] of TMsgInfo;
   function ShowEdit(einfo:TEditInfo):string;
   procedure SelectLine(alno:integer);
   procedure InsertMsg(amsg:string;acont:boolean=true;acolor:Tcolor=clblue);
   procedure Initialize;
   procedure Finalize;
   function UpdateInsBuffer(apos:integer;astep:boolean;refetch:boolean=false):integer;
   function GetLCDSymbol(ach:char):integer;
   procedure UpdateLCD;
   procedure UpdateRegisters;
   procedure UpdateMemo;
   procedure DisplayStatus;
   procedure Compile;
   procedure Execute;
   procedure Step(atrace:boolean=false);
   procedure Stop;
   function AskForSave:integer;
   function DoSaveAs:integer;
  public

  end;

var
  CPU: TCPU;
implementation
{$R *.dfm}
uses
 UAbout;
const MSG_CNT=10;
const IN_MAX =10;
const VAL_MAX=15;
const NR_COLOR=clblue;
const NF_COLOR=clmaroon;
const CH_COLOR=clpurple;

const EditFormat: array[0..4] of TEditInfo =
 (
  (msg:'Change Flag';
   mask:'0;0;0';
   length:1;
   replace:true;
   aset:['0'..'1'];
  ),
  (msg:'Change Value';
   mask:'CC;C;0';
   length:2;
   replace:true;
   aset:['0'..'9','A'..'F']
  ),
  (msg:'Goto';
   mask:'AAAA;A;0';
   length:4;
   replace:true;
   aset:['0'..'9','A'..'F']
  ),
  (msg:'Change Value';
   mask:'AAAA;A;0';
   length:4;
   replace:true;
   aset:['0'..'9','A'..'F']
  ),
  (msg:'Change Instruction';
   mask:'';
   length:0;
   replace:false;
   aset:['0'..'9','A'..'Z',' ',',',#8];
  )
 );

const LCD_SYM:array[-1..16] of TCellInfo=
 ((left1:false;left2:false;right1:false;right2:false;top1:false;top2:false;top3:false),
  (left1:true;left2:true;right1:true;right2:true;top1:true;top2:false;top3:true),
  (left1:false;left2:false;right1:true;right2:true;top1:false;top2:false;top3:false),
  (left1:false;left2:true;right1:true;right2:false;top1:true;top2:true;top3:true),
  (left1:false;left2:false;right1:true;right2:true;top1:true;top2:true;top3:true),
  (left1:true;left2:false;right1:true;right2:true;top1:false;top2:true;top3:false),
  (left1:true;left2:false;right1:false;right2:true;top1:true;top2:true;top3:true),
  (left1:true;left2:true;right1:false;right2:true;top1:true;top2:true;top3:true),
  (left1:true;left2:false;right1:true;right2:true;top1:true;top2:false;top3:false),
  (left1:true;left2:true;right1:true;right2:true;top1:true;top2:true;top3:true),
  (left1:true;left2:false;right1:true;right2:true;top1:true;top2:true;top3:true),
  (left1:true;left2:true;right1:true;right2:true;top1:true;top2:true;top3:false),
  (left1:true;left2:true;right1:false;right2:true;top1:false;top2:true;top3:true),
  (left1:true;left2:true;right1:false;right2:false;top1:true;top2:false;top3:true),
  (left1:false;left2:true;right1:true;right2:true;top1:false;top2:true;top3:true),
  (left1:true;left2:true;right1:false;right2:false;top1:true;top2:true;top3:true),
  (left1:true;left2:true;right1:false;right2:false;top1:true;top2:true;top3:false),
  (left1:false;left2:false;right1:false;right2:false;top1:false;top2:true;top3:false)
 );

procedure TCPU.Initialize;
var
 i:integer;
begin
 fProcessor:=T8085.Create;
 new(fbplist);ZeroMemory(fbplist,sizeof(TBPSpace));
 for i:=0 to VAL_MAX do ftmpvals[i]:=-1;
 forigin:=0;fmsgfront:=0;fmsgrear:=0;
 UpdateInsBuffer(-1,false,true);
 UpdateRegisters; 
end;

function TCPU.ShowEdit(einfo:TEditInfo):string;
begin
 FrmEdit:=TFrmEdit.Create(self);
 FrmEdit.Status:=einfo.msg;
 Frmedit.Mask:=einfo.mask;
 FrmEdit.length:=einfo.length;
 FrmEdit.Alphabet:=einfo.aset;
 FrmEdit.ShowModal;
 result:=FrmEdit.Result;
 Freeandnil(FrmEdit);
end;

procedure TCPU.SelectLine(alno:integer);
var
 pos1,pos2:integer;
begin
 if (alno<0) or (alno>=MemSource.Lines.Count) then exit;
 pos1:=SendMessage(MemSource.Handle,EM_LINEINDEX,alno,0);
 pos2:=SendMessage(MemSource.Handle,EM_LINELENGTH,pos1,0);
 MemSource.SelStart:=pos1;MemSource.Sellength:=pos2;
end;

procedure TCPU.DisplayStatus;
var
 cont:boolean;
begin
 LabStatus.font.Color:=fmsgqueue[fmsgfront].color;
 LabStatus.caption:=fmsgqueue[fmsgfront].name;
 cont:=fmsgqueue[fmsgfront].continue;
 if fmsgfront<>fmsgrear then
  fmsgfront:=(fmsgfront+1) mod MSG_CNT;
 if not cont or (fmsgfront=fmsgrear) then
  timer1.Enabled:=false
 else
  timer1.Enabled:=true;
end;

procedure TCPU.InsertMsg(amsg:string;acont:boolean=true;acolor:Tcolor=clblue);
begin
 fmsgqueue[fmsgrear].name:=amsg;
 fmsgqueue[fmsgrear].continue:=acont;
 fmsgqueue[fmsgrear].color:=acolor;
 fmsgrear:=(fmsgrear+1) mod MSG_CNT;
end;

procedure TCPU.UpdateMemo;
var
 tmp:integer;
begin
 LabCharno.caption:=inttostr(MemSource.SelStart);
 tmp:=SendMessage(memsource.Handle,EM_LINEFROMCHAR,-1,0);
 LabLno.Caption:=inttostr(tmp);
end;

procedure TCPU.UpdateRegisters;
var
 hval:array[0..3] of char;
 val:integer;
 procedure LSetColor(alabel:TLabel;idx:integer;cln:TColor=clblue;clc:TColor=clPurple);
 begin
  if (val<>ftmpvals[idx]) and (ftmpvals[idx]>=0) then
   alabel.Font.color:=clc
  else
   alabel.Font.color:=cln;
  ftmpvals[idx]:=val;
 end;
begin
 val:=fProcessor.RegisterA; DecToHex(val,hval);   LSetColor(RegValA,0);
 RegValA.Caption:=hval[2]+hval[3];
 val:=fProcessor.RegisterB; DecToHex(val,hval);   LSetColor(RegValB,1);
 RegValB.Caption:=hval[2]+hval[3];
 val:=fProcessor.RegisterC; DecToHex(val,hval);   LSetColor(RegValC,2);
 RegValC.Caption:=hval[2]+hval[3];
 val:=fProcessor.RegisterD; DecToHex(val,hval);   LSetColor(RegValD,3);
 RegValD.Caption:=hval[2]+hval[3];
 val:=fProcessor.RegisterE; DecToHex(val,hval);   LSetColor(RegValE,4);
 RegValE.Caption:=hval[2]+hval[3];
 val:=fProcessor.RegisterH; DecToHex(val,hval);   LSetColor(RegValH,5);
 RegValH.Caption:=hval[2]+hval[3];
 val:=fProcessor.RegisterL; DecToHex(val,hval);   LSetColor(RegValL,6);
 RegValL.Caption:=hval[2]+hval[3];
 val:=fProcessor.RegisterM; DecToHex(val,hval);   LSetColor(RegValM,7);
 RegValM.Caption:=hval[2]+hval[3];
 val:=fProcessor.RegisterPC; DecToHex(val,hval);  LSetColor(RegValPC,8);
 RegValPC.Caption:=hval;
 val:=fProcessor.RegisterSP; DecToHex(val,hval);  LSetColor(RegValSP,9);
 RegValSP.Caption:=hval;
 val:=fProcessor.RegisterPSW; DecToHex(val,hval); LSetColor(RegvalPSW,10);
 RegValPSW.Caption:=hval[2]+hval[3];
 FValSign.caption:=inttostr(fProcessor.FSign);     LSetColor(FValSign,11,NF_COLOR);
 FValZero.caption:=inttostr(fProcessor.FZero);     LSetColor(FValZero,12,NF_COLOR);
 FValCarry.caption:=inttostr(fProcessor.FCarry);   LSetColor(FValSign,13,NF_COLOR);
 FValAux.caption:=inttostr(fProcessor.FAuxCarry);  LSetColor(FValAux,14,NF_COLOR);
 FValParity.caption:=inttostr(fProcessor.FParity); LSetColor(FValParity,15,NF_COLOR);
 UpdateLCD;
end;

function TCPU.GetLCDSymbol(ach:char):integer;
begin
 case ach of
  '0':result:=0;
  '1':result:=1;
  '2':result:=2;
  '3':result:=3;
  '4':result:=4;
  '5':result:=5;
  '6':result:=6;
  '7':result:=7;
  '8':result:=8;
  '9':result:=9;
  'A':result:=10;
  'B':result:=11;
  'C':result:=12;
  'D':result:=13;
  'E':result:=14;
  'F':result:=15;
  '-':result:=16;
  else result:=-1;
 end;  
end;

procedure TCPU.UpdateLCD;
var
 val:array[0..3] of char;
 i:integer;
begin
 DecToHex(fprocessor.RegisterPC,val);
 for i:=1 to 4 do
  lcd1.ModifyCell(i,@LCD_SYM[GetLCDSymbol(val[i-1])]);
 lcd1.ModifyCell(5,@LCD_SYM[GetLCDSymbol('-')]);
 DecToHex(fprocessor.memory[fprocessor.RegisterPC],val);
 lcd1.ModifyCell(6,@LCD_SYM[GetLCDSymbol(val[2])]);
 lcd1.ModifyCell(7,@LCD_SYM[GetLCDSymbol(val[3])]);
end;

function TCPU.UpdateInsBuffer(apos:integer;astep:boolean;refetch:boolean=false):integer;
var
 tmp,i:integer;
 fnd:boolean;
begin
 if refetch=false then
  begin
   for i:=0 to IN_MAX do
    begin
     if finsinfo[i].pos=apos then
      begin
       if astep then fcurline:=i+1;
        result:=i+1;
        exit;
       end;
    end;
  end;
 if refetch and (apos<0) then forigin:=finsinfo[0].pos else forigin:=apos;
 if fstep then tmp:=fprocessor.RegisterPC else tmp:=-1;
 fnd:=false;
 for i:=0 to IN_MAX do
  begin
   finsinfo[i].pos:=forigin;
   if(forigin=tmp) then
    begin
     if fstep then fcurline:=i+1;
     fnd:=true;
    end;
   finsinfo[i].name:=fProcessor.GetInstruction(forigin,finsinfo[i].size,forigin);
  end;
 if not astep and not fnd then fcurline:=0
 else if astep then fcurline:=1;
 result:=1;
end;

procedure TCPU.Finalize;
begin
 freeandnil(fProcessor);
 dispose(fbplist);
end;
function TCPU.DoSaveAs:integer;
begin
 result:=ID_CANCEL;
 if SaveDialog1.Execute then
  begin
   fmodify:=false;
   fopenfile:=SaveDialog1.FileName;
   MemSource.Lines.SaveToFile(fopenfile);
   caption:=loadstr(22)+'-'+fopenfile;
   SpeedButton9.enabled:=true;
   SpeedButton10.enabled:=true;
   InsertMsg(LoadStr(12));
   InsertMsg(LoadStr(7));
   DisplayStatus;
   result:=ID_YES;
  end;
end;

function TCPU.AskForSave:integer;
var
 res:integer;
begin
 res:=ID_YES;
 if fmodify then
  begin
   res:=MessageBox(handle,pchar('File '+ fopenfile + ' not saved. Save?'),'Save File?',MB_YESNOCANCEL or MB_ICONQUESTION);
   if res= ID_YES then
    begin
     if fopenfile='' then res:=DoSaveAs
     else MemSource.Lines.SaveToFile(fopenfile);
    end;
  end;
 result:=res;
end;

procedure TCPU.Compile;
begin
 fstep:=false;
 if fProcessor.Ready then fProcessor.Terminate;
 fProcessor.CompileCode(MemSource.Lines);
 if(fProcessor.ErrorLine>=0) then
  begin
   InsertMsg(LoadStr(9) + inttostr(fProcessor.ErrorLine) +' -' + LoadStr(fProcessor.ErrorType),false,clred);
   SelectLine(fProcessor.ErrorLine);
   DisplayStatus;
  end
 else
  begin
   fcurline:=-1;
   UpdateInsBuffer(fProcessor.LoadAddress,false,true);
   UpdateRegisters;
   CodeGrid.Invalidate;MemGrid.Invalidate;
   InsertMsg(LoadStr(1)+ LoadStr(6)+Inttostr(fProcessor.InstructionCount));
   InsertMsg(LoadStr(7));
   DisplayStatus;
  end;
end;

procedure TCPU.Stop;
var
 i:integer;
begin
 for i:=0 to VAL_MAX do ftmpvals[i]:=-1; 
 fProcessor.Terminate;fcurline:=-1;fstep:=false;
 InsertMsg(LoadStr(21));
 InsertMsg(LoadStr(7));
 DisplayStatus;
 CodeGrid.Invalidate;
 UpdateRegisters;
end;

procedure TCPU.Execute;
var
 abyte,abit:integer;
 apos:integer;
 broke:boolean;
begin
 if not fProcessor.Ready then
  begin
   InsertMsg(Loadstr(19),false,clred);
   DisplayStatus; 
   exit;
  end;
 fstep:=true;broke:=false;
 InsertMsg(LoadStr(20));
 DisplayStatus;
 while fProcessor.Ready do
  begin
   apos:=fProcessor.RegisterPC;
   abyte:=apos div 32;abit:=apos mod 32;
   if (((fbplist[abyte] shr (31-abit)) and 1)=1) and
      ((fcurline<=0) or (finsinfo[fcurline-1].pos<>apos)) then
    begin
     broke:=true;
     break;
    end; 
   fProcessor.ExecuteLine;
   Application.ProcessMessages;
  end;
 UpdateInsBuffer(fProcessor.RegisterPC,true);
 if not broke then fstep:=false;
 UpdateRegisters;  
 CodeGrid.Invalidate;
 MemGrid.Invalidate;
end;

procedure TCPU.Step(atrace:boolean=false);
var
 idx:integer;
begin
 if fprocessor.Ready then
  begin
   if not fstep then
    begin
     fstep:=true;
     UpdateInsBuffer(fProcessor.RegisterPC,true);
     CodeGrid.Invalidate;
    end
   else
    begin
     if atrace then fProcessor.ExecuteLine
     else
      begin
       idx:=fprocessor.ProcIndex;
       repeat
        fProcessor.ExecuteLine;
       until fProcessor.ProcIndex<=idx;
      end;
     UpdateRegisters;
     UpdateInsBuffer(fProcessor.RegisterPC,true);
     CodeGrid.Refresh;
     MemGrid.Invalidate;
    end;
  end;
 if not fProcessor.ready then Stop;
end;


procedure TCPU.FormClose(Sender: TObject; var Action: TCloseAction);
var
 res:integer;
begin
 action:=caNone; 
 res:=askforsave;
 if res=ID_CANCEL then exit;
 action:=caFree;
 Finalize;
end;

procedure TCPU.FormCreate(Sender: TObject);
begin
 Initialize;
end;

procedure TCPU.CodeGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
 acolor:TColor;
 val:array[0..3] of char;
 i,tmp,abyte,abit:integer;
 prevc,hdc:integer;
 str:string;
begin
 hdc:=codegrid.canvas.handle;
 if (arow=0) then
  begin
   prevc:=SettextColor(hdc,clblack);
   with codegrid.canvas do
    begin
     case acol of
      0: TextOut(rect.left,rect.top,'Bp');
      1: TextOut(rect.left,rect.top,'Address');
      2: TextOut(rect.left,rect.top,'Mnemonics');
      3: TextOut(rect.left,rect.top,'OP Code');
     end;
    end;
   SettextColor(hdc,prevc);
  end;
 if (arow>0) and (arow=fcurline) then
  begin
   Codegrid.Canvas.brush.color:=clteal;
   Codegrid.Canvas.FillRect(rect);
  end;
 if (acol=0) and (arow>0) then
  begin
   tmp:=finsinfo[arow-1].pos;
   abyte:=tmp div 32;abit :=tmp mod 32;
   if ((fbplist[abyte] shr (31-abit)) and 1)=1 then
    begin
     OffSetRect(rect,3,5);
     rect.Right:=rect.Left+7;
     rect.bottom:=rect.top+7;
     with Codegrid.canvas do
      begin
       acolor:=Brush.color;
       Brush.color:=clRed;
       Ellipse(rect);
       Brush.color:=acolor;
      end;
    end;
  end
 else if(acol=1) and (arow>=1) then
  begin
   OffSetRect(rect,3,0);
   DecToHex(finsinfo[arow-1].pos,val);
   CodeGrid.Canvas.TextOut(rect.left,rect.top,val);
  end
 else if(acol=2) and (arow>=1) then
  begin
   CodeGrid.Canvas.TextOut(rect.Left,rect.top,finsinfo[arow-1].name);
  end
 else if(acol=3) and (arow>=1) then
  begin
   tmp:=finsinfo[arow-1].pos;
   for i:=tmp to tmp+finsinfo[arow-1].size-1 do
    begin
     DecToHex(fprocessor.Memory[i],val);
     str:=str + val[2] + val[3] + ' ';
    end;
   CodeGrid.Canvas.TextOut(rect.Left,rect.top,str);
  end;
end;

procedure TCPU.CodeGridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
 tmp,acol,arow:integer;
 arect:Trect;
 abyte,abit:integer;
begin
 CodeGrid.MouseToCell(x,y,acol,arow);
 if (button=mbleft) then
  begin
   if (acol=0)and (arow>0) then
    begin
     tmp:=finsinfo[arow-1].pos;
     abyte:=tmp div 32;abit:=tmp mod 32;
     if ((fbplist[abyte] shr (31-abit)) and 1)=1 then
      fbplist[abyte]:=fbplist[abyte] and not (1 shl(31-abit))
     else
      fbplist[abyte]:=fbplist[abyte] or (1 shl(31-abit));
     arect:=CodeGrid.CellRect(acol,arow);
     InvalidateRect(CodeGrid.handle,@arect,false);
    end;
  end
 else if (button=mbright) then
  CodeGrid.Row:=arow;
end;

procedure TCPU.CodeBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
 if ScrollCode=scLineDown then
  UpdateInsBuffer(finsinfo[1].pos,false,true)
 else
  ScrollPos:=CodeBar.Position;
 Scrollpos:=finsinfo[0].pos;
end;

procedure TCPU.CodeBarChange(Sender: TObject);
begin
 CodeGrid.Invalidate;
end;

procedure TCPU.MemGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
 pos:integer;
 val:array[0..4] of char;
 prevc,hdc:integer;
begin
 val[4]:=#0;
 with MemGrid.Canvas do
  begin
   hdc:=handle;
   if(acol>0) and (arow=0) then
    begin
     pos:=acol-1;DecToHex(pos,val);
     Offsetrect(rect,1,0);
     prevc:=SettextColor(hdc,clblack);
     TextOut(rect.left,rect.top,val[2]+val[3]);
     SettextColor(hdc,prevc);
    end
   else if (acol=0) and (arow>0) then
    begin
     Offsetrect(rect,7,0);
     pos:=(membar.position+arow-1)*16;
     DecToHex(pos,val);
     prevc:=SettextColor(hdc,clblack);
     TextOut(rect.left,rect.top,val);
     SettextColor(hdc,prevc);
    end
   else if arow>0 then
    begin
     pos:=fProcessor.Memory[(arow+Membar.position-1)*16 + acol-1];
     DecTohex(pos,val);
     TextOut(rect.left,rect.top,pchar(@val[2]));
    end
  end;
end;

procedure TCPU.MemBarChange(Sender: TObject);
begin
 MemGrid.Invalidate;
end;

procedure TCPU.MemGridGetEditText(Sender: TObject; ACol, ARow: Integer;
  var Value: String);
var
 pos:integer;
 val:array[0..3] of char;
begin
 pos:=fProcessor.Memory[(arow+Membar.position-1)*16 + acol-1];
 ftmpval:=byte(pos);
 DecTohex(pos,val);
 value:=val[2]+val[3];
end;

procedure TCPU.MemGridSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
var
 pos:integer;
begin
 if ftmpval<>-1 then
  begin
   if Length(trim(value))<>2 then exit;
   pos:=HexToDec(pchar(Value));
   fProcessor.Memory[(arow+Membar.position-1)*16 + acol-1]:=pos;
   UpdateInsBuffer(-1,false,true);
   CodeGrid.Invalidate;
   UpdateRegisters;
   UpdateLCD;
  end;
end;

procedure TCPU.MemGridKeyPress(Sender: TObject; var Key: Char);
begin
 key:=Upcase(key);
 if not (key in ['0','1','2','3','4','5','6','7','8','9',
                 'A','B','C','D','E','F',#27]) then
  key:=#0;
 if key=#27 then
  begin
   fProcessor.Memory[(Membar.position+memgrid.row-1)*16 + Memgrid.col-1]:=ftmpval;
   ftmpval:=-1;Memgrid.EditorMode:=false;
   UpdateInsBuffer(-1,false,true);
   CodeGrid.Invalidate;
   key:=#0;
  end;
end;

procedure TCPU.Timer1Timer(Sender: TObject);
begin
 DisplayStatus;
end;

procedure TCPU.MemSourceClick(Sender: TObject);
begin
 UpdateMemo;
end;

procedure TCPU.MemSourceKeyPress(Sender: TObject; var Key: Char);
begin
 UpdateMemo;
end;

procedure TCPU.MemSourceKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 UpdateMemo;
end;

procedure TCPU.ActCompileHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Compile: Shortcut Key '+ ShortCutTotext(ActCompile.ShortCut));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.SpeedButton1Click(Sender: TObject);
begin
 Compile;
end;

procedure TCPU.SpeedButton2Click(Sender: TObject);
begin
 Execute;
end;

procedure TCPU.SpeedButton3Click(Sender: TObject);
begin
 Step;
end;


procedure TCPU.SpeedButton4Click(Sender: TObject);
begin
 Stop;
end;

procedure TCPU.ActTerminateHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Terminate: Shortcut Key '+ ShortCutTotext(ActTerminate.ShortCut));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.ActStepHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Step: Shortcut Key '+ ShortCutTotext(ActStep.ShortCut));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.ActExecuteHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Execute: Shortcut Key '+ ShortCutTotext(ActExecute.ShortCut));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.MenGotoClick(Sender: TObject);
var
 res:string;
 val:integer;
 agrid:TDrawGrid;
begin
 agrid:=TDrawGrid(MenGoto.tag);
 if agrid=CodeGrid then
  begin
   res:=ShowEdit(EditFormat[2]);
   if res='' then exit;
   val:=HexToDec(pchar(res));
   if (val>=0) and (val<=$FFFF) then
    begin
     codegrid.row:=UpdateInsBuffer(val,false);
     CodeGrid.Invalidate;
    end;
  end
 else if agrid=MemGrid then
  begin
   res:=ShowEdit(EditFormat[2]);
   if res='' then exit;
   val:=HexToDec(pchar(res));
   if (val>=0) and (val<=$FFFF) then
    begin
     MemBar.Position:= val div 16;
     memgrid.col:=(val mod 16)+1;
     MemGrid.Invalidate;
    end;
  end;
end;

procedure TCPU.MemGridContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
 popupmenu1.Items[0].Visible:=true;
 popupmenu1.Items[1].Visible:=false;
 popupmenu1.Items[2].Visible:=false;
 popupmenu1.Items[3].Visible:=false;
 MenGoto.Tag:=Integer(sender);
end;

procedure TCPU.RegValAContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
 PopupMenu1.Items[0].visible:=false;
 PopupMenu1.Items[1].visible:=true;
 PopupMenu1.Items[2].visible:=false;
 popupmenu1.Items[3].Visible:=false; 
 MenCValue.Tag:=integer(Sender);
end;

procedure TCPU.MenCValueClick(Sender: TObject);
var
 val:integer;
 alabel:TLabel;
 res:string;
begin
 alabel:=TLabel(MenCValue.tag);
 if alabel=RegValA then
  begin
   res:=ShowEdit(EditFormat[1]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>0) and (val<$FF) then fProcessor.RegisterA:=val;
  end
 else if alabel=RegValB then
  begin
   res:=ShowEdit(EditFormat[1]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>0) and (val<$FF) then fProcessor.RegisterB:=val;
  end
 else if alabel=RegValC then
  begin
   res:=ShowEdit(EditFormat[1]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>0) and (val<$FF) then fProcessor.RegisterC:=val;
  end
 else if alabel=RegValD then
  begin
   res:=ShowEdit(EditFormat[1]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$FF) then fProcessor.RegisterD:=val;
  end
 else if alabel=RegValE then
  begin
   res:=ShowEdit(EditFormat[1]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$FF) then fProcessor.RegisterE:=val;
  end
 else if alabel=RegValH then
  begin
   res:=ShowEdit(EditFormat[1]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$FF) then fProcessor.RegisterH:=val;
  end
 else if alabel=RegValL then
  begin
   res:=ShowEdit(EditFormat[1]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$FF) then fProcessor.RegisterL:=val;
  end
 else if alabel=RegValM then
  begin
   res:=ShowEdit(EditFormat[1]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$FF) then
    begin
     fProcessor.RegisterM:=val;
     MemGrid.Invalidate;
    end;
  end
 else if alabel=RegValPSW then
  begin
   res:=ShowEdit(EditFormat[1]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$FF) then fProcessor.RegisterPSW:=val;
  end
 else if alabel=RegValSP then
  begin
   res:=ShowEdit(EditFormat[2]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$FFFF) then fProcessor.RegisterSP:=val;
  end
 else if alabel=RegValPC then
  begin
   res:=ShowEdit(EditFormat[3]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$FFFF) then fProcessor.RegisterPC:=val;
  end
 else if alabel=FValSign then
  begin
   res:=ShowEdit(EditFormat[0]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$1) then fProcessor.FSign:=val;
  end
 else if alabel=FValZero then
  begin
   res:=ShowEdit(EditFormat[0]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$1) then fProcessor.FZero:=val;
  end
 else if alabel=FValAux then
  begin
   res:=ShowEdit(EditFormat[0]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$1) then fProcessor.FAuxCarry:=val;
  end
 else if alabel=FValParity then
  begin
   res:=ShowEdit(EditFormat[0]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$1) then fProcessor.FParity:=val;
  end
 else if alabel=FValCarry  then
  begin
   res:=ShowEdit(EditFormat[0]);
   if res='' then exit;
   val:=hextoDec(pchar(res));
   if (val>=0) and (val<=$1) then fProcessor.FCarry:=val;
  end;
 UpdateRegisters;
end;

procedure TCPU.MemGridGetEditMask(Sender: TObject; ACol, ARow: Integer;
  var Value: String);
begin
 if (acol>0)and(arow>0) then value:='CC';
end;

procedure TCPU.ActSaveAsHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Save Source File As:');
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.SpeedButton6Click(Sender: TObject);
var
 res:integer;
begin
 if fmodify then
  begin
   res:=askforsave;
   if res=ID_CANCEL then exit;
  end;
 if OpenDialog1.Execute then
  begin
   fopenfile:=OpenDialog1.FileName;
   MemSource.lines.LoadFromFile(fopenfile);
   fmodify:=false;SpeedButton9.Enabled:=false;
   caption:=LoadStr(22)+ '-' + fopenfile;
   SpeedButton10.Enabled:=true;
   InsertMsg(LoadStr(13));
   InsertMsg(LoadStr(7));
   DisplayStatus;
  end;
end;

procedure TCPU.ActOpenHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Open Source File: Shortcut Key '+ ShortCutTotext(ActOpen.ShortCut));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.SpeedButton7Click(Sender: TObject);
begin
 fProcessor.Ready:=true;
 InsertMsg(LoadStr(14));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.ActResetHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Reset: Shortcut Key '+ ShortCutTotext(ActReset.ShortCut));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.CodeGridContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
 popupmenu1.Items[0].Visible:=true;
 popupmenu1.Items[1].Visible:=false;
 popupmenu1.Items[2].Visible:=true;
 popupmenu1.Items[3].Visible:=true;
 MenGoto.Tag:=Integer(sender);
end;

procedure TCPU.MenCinsClick(Sender: TObject);
var
 res:string;
begin
 res:=ShowEdit(EditFormat[4]);if res='' then exit;
 fProcessor.CompileLine(res,finsinfo[codegrid.row-1].pos);
 if fProcessor.ErrorType>0 then
  begin
   InsertMsg(LoadStr(fProcessor.ErrorType),false,clred);
   DisplayStatus;
  end
 else
  begin
   UpdateInsBuffer(-1,false,true);
   UpdateRegisters;
   InsertMsg(LoadStr(15));
   InsertMsg(LoadStr(7));
   DisplayStatus;
   MemGrid.Invalidate;
   CodeGrid.Invalidate;
  end;
end;

procedure TCPU.SourceBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
 SendMessage(Memsource.handle,WM_VSCROLL,(scrollpos shl 16) or Integer(ScrollCode),0);
end;

procedure TCPU.SpeedButton8Click(Sender: TObject);
begin
 Cpu.close;
end;

procedure TCPU.ActExitHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Exit: Shortcut Key '+ ShortCutTotext(ActClose.ShortCut));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.ClearAllBreakpoints1Click(Sender: TObject);
begin
 ZeroMemory(fbplist,sizeof(TBPSpace));
 CodeGrid.Invalidate;
end;

procedure TCPU.ActSaveHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Save Source File: Shortcut Key '+ ShortCutTotext(MasterSave.ShortCut));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

procedure TCPU.SpeedButton9Click(Sender: TObject);
begin
 if fmodify then
  begin
   fmodify:=false;
   SpeedButton9.enabled:=false;
   MemSource.Lines.SaveToFile(fopenfile);
   InsertMsg(LoadStr(12));
   InsertMsg(LoadStr(7));
   DisplayStatus;
  end;
end;

procedure TCPU.SpeedButton10Click(Sender: TObject);
begin
 if fmodify then
  begin
   if askforsave=ID_CANCEL then exit;
  end;
 fopenfile:='';fmodify:=false;
 caption:=Loadstr(22);
 memsource.Lines.Clear;
 SpeedButton5.enabled:=false; 
 SpeedButton9.enabled:=false;
 SpeedButton10.enabled:=false;
end;

procedure TCPU.MemSourceChange(Sender: TObject);
begin
 fmodify:=true;
 if fopenfile<>'' then
  SpeedButton9.enabled:=true;
 SpeedButton5.enabled:=true;
end;

procedure TCPU.FormShow(Sender: TObject);
begin
 SpeedButton5.Enabled:=false;
 SpeedButton9.Enabled:=false;
 SpeedButton10.Enabled:=false;  
end;

procedure TCPU.MasterSaveExecute(Sender: TObject);
begin
 if fopenfile='' then ActSaveAs.Execute
 else ActSave.Execute;  
end;

procedure TCPU.SpeedButton5Click(Sender: TObject);
begin
 DoSaveAs;
end;

procedure TCPU.CodeGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (codegrid.Row=codegrid.RowCount-1) and (key=VK_DOWN) then
  begin
   UpdateInsBuffer(finsinfo[1].pos,false,true);
   CodeGrid.Invalidate;
  end;
end;

procedure TCPU.SpeedButton11Click(Sender: TObject);
begin
 DlgAbout:=TDlgAbout.Create(self);
 DlgAbout.ShowModal;
 Freeandnil(DlgAbout);
end;

procedure TCPU.SpeedButton12Click(Sender: TObject);
begin
 Step(true);
end;

procedure TCPU.ActTraceHint(var HintStr: String; var CanShow: Boolean);
begin
 InsertMsg('Step: Shortcut Key '+ ShortCutTotext(ActTrace.ShortCut));
 InsertMsg(LoadStr(7));
 DisplayStatus;
end;

end.
